# Ogre::ParticleSystemRenderer Class Reference
[Effects]

Abstract class defining the interface required to be implemented by classes which provide rendering capability to ParticleSystem instances. More...

`#include <OgreParticleSystemRenderer.h>`

Inheritance diagram for Ogre::ParticleSystemRenderer:
[legend]

List of all members.

## Public Member Functions

| ParticleSystemRenderer ()
| Constructor.
virtual | ~ParticleSystemRenderer ()
| Destructor.
virtual const String & | getType (void) const =0
| Gets the type of this renderer - must be implemented by subclasses.
virtual void | _updateRenderQueue (RenderQueue *queue, list< Particle * >::type &currentParticles, bool cullIndividually)=0
| Delegated to by ParticleSystem::_updateRenderQueue.
virtual void | _setMaterial (MaterialPtr &mat)=0
| Sets the material this renderer must use; called by ParticleSystem.
virtual void | _notifyCurrentCamera (Camera *cam)=0
| Delegated to by ParticleSystem::_notifyCurrentCamera.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)=0
| Delegated to by ParticleSystem::_notifyAttached.
virtual void | _notifyParticleRotated (void)
| Optional callback notified when particles are rotated.
virtual void | _notifyParticleResized (void)
| Optional callback notified when particles are resized individually.
virtual void | _notifyParticleQuota (size_t quota)=0
| Tells the renderer that the particle quota has changed.
virtual void | _notifyDefaultDimensions (Real width, Real height)=0
| Tells the renderer that the particle default size has changed.
virtual void | _notifyParticleEmitted (Particle *particle)
| Optional callback notified when particle emitted.
virtual void | _notifyParticleExpired (Particle *particle)
| Optional callback notified when particle expired.
virtual void | _notifyParticleMoved (list< Particle * >::type &currentParticles)
| Optional callback notified when particles moved.
virtual void | _notifyParticleCleared (list< Particle * >::type &currentParticles)
| Optional callback notified when particles cleared.
virtual ParticleVisualData * | _createVisualData (void)
| Create a new ParticleVisualData instance for attachment to a particle.
virtual void | _destroyVisualData (ParticleVisualData *vis)
| Destroy a ParticleVisualData instance.
virtual void | setRenderQueueGroup (uint8 queueID)=0
| Sets which render queue group this renderer should target with it's output.
virtual void | setKeepParticlesInLocalSpace (bool keepLocal)=0
| Setting carried over from ParticleSystem.
virtual SortMode | _getSortMode (void) const =0
| Gets the desired particles sort mode of this renderer.
virtual void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)=0
| Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Member Functions

bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Detailed Description

Abstract class defining the interface required to be implemented by classes which provide rendering capability to ParticleSystem instances.

Definition at line 49 of file OgreParticleSystemRenderer.h.

## Constructor & Destructor Documentation

Ogre::ParticleSystemRenderer::ParticleSystemRenderer | ( |  | ) |

Constructor.

Definition at line 53 of file OgreParticleSystemRenderer.h.

virtual Ogre::ParticleSystemRenderer::~ParticleSystemRenderer | ( |  | ) | `[virtual]`

Destructor.

Definition at line 55 of file OgreParticleSystemRenderer.h.

## Member Function Documentation

virtual ParticleVisualData* Ogre::ParticleSystemRenderer::_createVisualData | ( | void |  | ) | `[virtual]`

Create a new ParticleVisualData instance for attachment to a particle.

Remarks:
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to return a new instance of it. The default behaviour is to return null.

Definition at line 97 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_destroyVisualData | ( | ParticleVisualData * | vis | ) | `[virtual]`

Destroy a ParticleVisualData instance.

Remarks:
  If this renderer needs additional data in each particle, then this should be held in an instance of a subclass of ParticleVisualData, and this method should be overridden to destroy an instance of it. The default behaviour is to do nothing.

Definition at line 105 of file OgreParticleSystemRenderer.h.

virtual SortMode Ogre::ParticleSystemRenderer::_getSortMode | ( | void |  | ) | const`[pure virtual]`

Gets the desired particles sort mode of this renderer.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[pure virtual]`

Delegated to by ParticleSystem::_notifyAttached.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_notifyCurrentCamera | ( | Camera * | cam | ) | `[pure virtual]`

Delegated to by ParticleSystem::_notifyCurrentCamera.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_notifyDefaultDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[pure virtual]`

Tells the renderer that the particle default size has changed.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleCleared | ( | list< Particle * >::type & | currentParticles | ) | `[virtual]`

Optional callback notified when particles cleared.

Definition at line 89 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleEmitted | ( | Particle * | particle | ) | `[virtual]`

Optional callback notified when particle emitted.

Definition at line 83 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleExpired | ( | Particle * | particle | ) | `[virtual]`

Optional callback notified when particle expired.

Definition at line 85 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleMoved | ( | list< Particle * >::type & | currentParticles | ) | `[virtual]`

Optional callback notified when particles moved.

Definition at line 87 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleQuota | ( | size_t | quota | ) | `[pure virtual]`

Tells the renderer that the particle quota has changed.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleResized | ( | void |  | ) | `[virtual]`

Optional callback notified when particles are resized individually.

Reimplemented in Ogre::BillboardParticleRenderer.

Definition at line 77 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_notifyParticleRotated | ( | void |  | ) | `[virtual]`

Optional callback notified when particles are rotated.

Reimplemented in Ogre::BillboardParticleRenderer.

Definition at line 75 of file OgreParticleSystemRenderer.h.

virtual void Ogre::ParticleSystemRenderer::_setMaterial | ( | MaterialPtr & | mat | ) | `[pure virtual]`

Sets the material this renderer must use; called by ParticleSystem.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::_updateRenderQueue | ( | RenderQueue * | queue,
|  | list< Particle * >::type & | currentParticles,
|  | bool | cullIndividually |
| ) |  |  | `[pure virtual]`

Delegated to by ParticleSystem::_updateRenderQueue.

Remarks:
  The subclass must update the render queue using whichever Renderable instance(s) it wishes.

Implemented in Ogre::BillboardParticleRenderer.

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual const String& Ogre::ParticleSystemRenderer::getType | ( | void |  | ) | const`[pure virtual]`

Gets the type of this renderer - must be implemented by subclasses.

Implemented in Ogre::BillboardParticleRenderer.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::ParticleSystemRenderer::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) | `[pure virtual]`

Setting carried over from ParticleSystem.

Implemented in Ogre::BillboardParticleRenderer.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual void Ogre::ParticleSystemRenderer::setRenderQueueGroup | ( | uint8 | queueID | ) | `[pure virtual]`

Sets which render queue group this renderer should target with it's output.

Implemented in Ogre::BillboardParticleRenderer.

virtual void Ogre::ParticleSystemRenderer::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[pure virtual]`

Required method to allow the renderer to communicate the Renderables it will be using to render the system to a visitor.

See also:
  MovableObject::visitRenderables

Implemented in Ogre::BillboardParticleRenderer.

The documentation for this class was generated from the following file:

- OgreParticleSystemRenderer.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:58